-- Some Constants
local xtRed = 1.0
local xtGreen = 0.9
local xtBlue = 0.1
local xtIdentifier = "x'Talk"
local xtAlliance = "oGErin"
local xtHorde = "nEVren"

-- Determine Player Faction

local faction =
{
Orc = "Horde",
Tauren = "Horde",
Undead = "Horde",
Troll = "Horde",
Human = "Alliance",
Dwarf = "Alliance",
Gnome = "Alliance",
Draenei = "Alliance"
}

faction["Blood Elf"] = "Horde"
faction["Night Elf"] = "Alliance"

local playerFaction = faction[UnitRace("player")];

-- Encode Order:

-- space
-- 32

-- e   a   i   o   n   r   t   l   s   u   d   g   b
-- 101 97  105 111 110 114 116 108 115 117 100 103 98

-- c   m   p   f   h   v   w   y   k   j   x   q   z
-- 99  109 112 102 104 118 119 121 107 106 120 113 122

-- E   A   I   O   N   R   T   L   S   U   D   G   B
-- 69  65  73  79  78  82  84  76  83  85  68  71  66

-- C   M   P   F   H   V   W   Y   K   J   X   Q   Z
-- 67  77  80  70  72  86  87  89  75  74  88  81  90 

-- 0   1   2   3   4   5   6   7   8   9
-- 48  49  50  51  52  53  54  55  56  57

-- .   ,   !   ?   '   "   ;   :   -   (   )   /
-- 46  44  33  63  39  34  59  58  45  40  41  47

local charTotal = 75;
local charEncode =
{32,
101,97,105,111,110,114,116,108,115,117,100,103,98,
99,109,112,102,104,118,119,121,107,106,120,113,122,
69,65,73,79,78,82,84,76,83,85,68,71,66,
67,77,80,70,72,86,87,89,75,74,88,81,90,
48,49,50,51,52,53,54,55,56,57,
46,44,33,63,39,34,59,58,45,40,41,47}

local charDecode =
{" ",
"e","a","i","o","n","r","t","l","s","u","d","g","b",
"c","m","p","f","h","v","w","y","k","j","x","q","z",
"E","A","I","O","N","R","T","L","S","U","D","G","B",
"C","M","P","F","H","V","W","Y","K","J","X","Q","Z",
"0","1","2","3","4","5","6","7","8","9",
".",",","!","?","\'","\"",";",":","-","(",")","/"}

-- Orcish codes...
local orcishEncode =
{"a","c","d","f","j",
"A","C","D","F","J",
"aa","aA","Aa","AA",
"ab","aB","Ab","AB",
"ag","aG","Ag","AG",
"ap","aP","Ap","AP",
"aw","aW","Aw","AW",
"bb","bB","Bb","BB",
"bg","bG","Bg","BG",
"bw","bW","Bw","BW",
"aaa","Aaa","aAa","aaA","AAa","AaA","aAA","AAA",
"aab","Aab","aAb","aaB","AAb","AaB","aAB","AAB",
"aae","Aae","aAe","aaE","AAe","AaE","aAE","AAE",
"aag","Aag","aAg","aaG","AAg","AaG","aAG","AAG",
"aam","Aam","aAm","aaM","AAm","AaM","aAM","AAM"}

-- ...and the texts that appears to Alliance players
local orcishDecode =
{"g","o","l","a","n",
"G","O","L","A","N",
"ag","aG","Ag","AG",
"ha","hA","Ha","HA",
"gi","gI","Gi","GI",
"ka","kA","Ka","KA",
"no","nO","No","NO",
"ko","kO","Ko","KO",
"il","iL","Il","IL",
"mu","mU","Mu","MU",
"mog","Mog","mOg","moG","MOg","MoG","mOG","MOG",
"aaz","Aaz","aAz","aaZ","AAz","AaZ","aAZ","AAZ",
"tar","Tar","tAr","taR","TAr","TaR","tAR","TAR",
"gul","Gul","gUl","guL","GUl","GuL","gUL","GUL",
"ruk","Ruk","rUk","ruK","RUk","RuK","rUK","RUK"}

-- Common codes...
local commonEncode =
{"a","b","d","p",
"A","B","D","P",
"aa","aA","Aa","AA",
"ac","aC","Ac","AC",
"ad","aD","Ad","AD",
"ag","aG","Ag","AG",
"am","aM","Am","AM",
"ap","aP","Ap","AP",
"ba","bA","Ba","BA",
"bc","bC","Bc","BC",
"bg","bG","Bg","BG",
"bm","bM","Bm","BM",
"ca","cA","Ca","CA",
"dc","dC","Dc","DC",
"aaa","Aaa","aAa","aaA","AAa","AaA","aAA","AAA",
"aab","Aab","aAb","aaB","AAb","AaB","aAB","AAB",
"aac","Aac","aAC","aaC","AAc","AaC","aAC","AAC"}

-- ..and the texts that appears to Horde players
local commonDecode =
{"o","e","y","u",
"O","E","Y","U",
"re","rE","Re","RE",
"lo","lO","Lo","LO",
"an","aN","An","AN",
"me","mE","Me","ME",
"ve","vE","Ve","VE",
"se","sE","Se","SE",
"ti","tI","Ti","TI",
"ne","nE","Ne","NE",
"ko","kO","Ko","KO",
"ru","rU","Ru","RU",
"va","vA","Va","VA",
"lu","lU","Lu","LU",
"gol","Gol","gOl","goL","GOl","GoL","gOL","GOL",
"bur","Bur","bUr","buR","BUr","BuR","bUR","BUR",
"nud","Nud","nUd","nuD","NUd","NuD","nUD","NUD"}

local charEncodeIndex = {};
local orcishEncodeIndex = {};
local orcishDecodeIndex = {};
local commonEncodeIndex = {};
local commonDecodeIndex = {};

local translate = false;
local bufferLimit = 100;

-- Some simple utilities
function xtMessage(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg, xtRed, xtGreen, xtBlue);
end
	
function xtCommand(command)
	if (command == "on") then
		translate = true;
		xtMessage("xTalk turned on. Those who don't have xTalk will see jibberish.");
	else
		translate = false;
		xtMessage("xTalk turned off. You are speaking normally now.");
	end
end

local function xtEncode(chatEntry, send)

	local encode = xtIdentifier.." ";
	local encodeTable;
	
	local text = chatEntry:GetText();
		
	-- encode only if player is trying to send and xTalk is turned on
	if (send == 1 and translate) then
		
		-- distinguish factions
		if (playerFaction == "Alliance") then
			encodeTable = commonEncode;
		elseif (playerFaction == "Horde") then
			encodeTable = orcishEncode;
		end
		
		if (strlen(text) == 0) then
			return;
		end
		
		-- begin translation
		local i;
		local code;
		for i = 1 , strlen(text) do
			code = strbyte(text, i);
			if (charEncodeIndex[code] ~= nil) then
				encode = encode..encodeTable[charEncodeIndex[code]].." ";
			end
		end
		
		chatEntry:SetText(encode);
	end
end

local function txDecode(text)

	local decodeTable;
	local decode = "";
	local word;
	
	local localTable;
	local foreignTable;
	
	-- xtMessage("incoming text: "..text);
	
	-- Determine whether it's an encoded message
	if (playerFaction == "Alliance") then
		if (string.find(text, xtIdentifier)) then
			decode = "[xTalk] ";
			decodeTable = commonEncodeIndex;
		elseif (string.find(text, xtAlliance)) then
			decode = "[xTalk] ";
			decodeTable = orcishDecodeIndex;
		else
			return false, text;
		end
	end
	
	if (playerFaction == "Horde") then
		if (string.find(text, xtIdentifier)) then
			decode = "[xTalk] ";
			decodeTable = orcishEncodeIndex;
		elseif (string.find(text, xtHorde)) then
			decode = "[xTalk] ";
			decodeTable = commonDecodeIndex;
		else
			return false, text;
		end
	end
	
	-- translate
	for word in text:gmatch("%w+") do	
		if (decodeTable[word] ~= nil) then
			decode = decode..charDecode[decodeTable[word]];
		end
	end
	
	return false, decode;
end

function xtLoad()

	-- build index tables
	local i;
	for i = 1, charTotal do
		charEncodeIndex[charEncode[i]] = i;
		orcishEncodeIndex[orcishEncode[i]] = i;
		orcishDecodeIndex[orcishDecode[i]] = i;
		commonEncodeIndex[commonEncode[i]] = i;
		commonDecodeIndex[commonDecode[i]] = i;
	end
	
	-- add slash commands
	 SlashCmdList["XTALK"] = xtCommand;
	 SLASH_XTALK1 = "/xt";
	 SLASH_XTALK2 = "/xtalk";

	-- hook into chat
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", txDecode)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", txDecode)
	hooksecurefunc('ChatEdit_ParseText', xtEncode)

	-- show init message
	xtMessage("xrossTalk Initialized", xtRed, xtGreen, xtBlue);
	xtMessage("To speak in xTalk use /xt on, use /xt off to speak normally");
	xtMessage("NOTE: Type short sentences while xTalk is turned on");
end


